/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"time"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
)

type propCommon struct {
	iri string // resource iri
	typ string // type of resource
	model *Model // pointer to model
}

// propSarefConsistsOfBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice is A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
type propSarefConsistsOfBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice struct {
	sarefConsistsOf map[string]SarefDevice
}

// propSarefControlsPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty is A relationship specifying the Property that can be controlled by a certain Device
type propSarefControlsPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty struct {
	sarefControlsProperty map[string]SarefProperty
}

// propSarefHasProfileBaseSarefProfileTypeSarefProfileMultipleSarefProfile is A relationship associating a profile to a certain entity (e.g., a device)
type propSarefHasProfileBaseSarefProfileTypeSarefProfileMultipleSarefProfile struct {
	sarefHasProfile map[string]SarefProfile
}

// propSarefHasStateBaseSarefStateTypeSarefStateMultipleSarefState is A relationship identifying the type of state of a device
type propSarefHasStateBaseSarefStateTypeSarefStateMultipleSarefState struct {
	sarefHasState map[string]SarefState
}

// propSarefHasTypicalConsumptionBaseSarefPropertyTypeSarefPropertyMultipleSarefEnergySarefPower is A relationship identifying the typical (energy or power) consumption of a device
type propSarefHasTypicalConsumptionBaseSarefPropertyTypeSarefPropertyMultipleSarefEnergySarefPower struct {
	sarefHasTypicalConsumption map[string]SarefProperty
}

// propSarefIsUsedForBaseSarefCommodityTypeSarefCommodityMultipleSarefCommodity is A relationship specifying the purpose for which a device is used for (e.g., controlling a Commodity)
type propSarefIsUsedForBaseSarefCommodityTypeSarefCommodityMultipleSarefCommodity struct {
	sarefIsUsedFor map[string]SarefCommodity
}

// propSarefMakesMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement is A relation between a device and the measurements it makes. Such measurement will link together the value of the measurement, its unit of measure and the property to which it relates.
type propSarefMakesMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement struct {
	sarefMakesMeasurement map[string]SarefMeasurement
}

// propSarefMeasuresPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty is A relationship specifying the Property that can be measured by a certain Device
type propSarefMeasuresPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty struct {
	sarefMeasuresProperty map[string]SarefProperty
}

// propSarefOffersBaseSarefServiceTypeSarefServiceMultipleSarefService is A relationship between a device and a service
type propSarefOffersBaseSarefServiceTypeSarefServiceMultipleSarefService struct {
	sarefOffers map[string]SarefService
}

// propSarefAccomplishesBaseSarefTaskTypeSarefTaskMultipleSarefTask is A relationship between a certain entity (e.g., a device) and the task it accomplishes
type propSarefAccomplishesBaseSarefTaskTypeSarefTaskMultipleSarefTask struct {
	sarefAccomplishes map[string]SarefTask
}

// propSarefHasFunctionBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction is A relationship identifying the type of function of a device
type propSarefHasFunctionBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction struct {
	sarefHasFunction map[string]SarefFunction
}

// propSarefHasDescriptionBasestringTypestringSinglestring is A relationship providing a description of an entity (e.g., device)
type propSarefHasDescriptionBasestringTypestringSinglestring struct {
	sarefHasDescription string
}

// propSarefHasManufacturerBasestringTypestringSinglestring is A relationship identifying the manufacturer of an entity (e.g., device)
type propSarefHasManufacturerBasestringTypestringSinglestring struct {
	sarefHasManufacturer string
}

// propSarefHasModelBasestringTypestringSinglestring is A relationship identifying the model of an entity (e.g., device)
type propSarefHasModelBasestringTypestringSinglestring struct {
	sarefHasModel string
}

// propSarefHasFunctionBaseSarefFunctionTypeSarefMeteringFunctionMultipleSarefMeteringFunction is A relationship identifying the type of function of a device
type propSarefHasFunctionBaseSarefFunctionTypeSarefMeteringFunctionMultipleSarefMeteringFunction struct {
	sarefHasFunction map[string]SarefMeteringFunction
}

// propSarefActsUponBaseSarefStateTypeSarefMultiLevelStateMultipleSarefMultiLevelState is A relationship between a command and a state
type propSarefActsUponBaseSarefStateTypeSarefMultiLevelStateMultipleSarefMultiLevelState struct {
	sarefActsUpon map[string]SarefMultiLevelState
}

// propSarefIsCommandOfBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction is A relationship between a command and a function.
type propSarefIsCommandOfBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction struct {
	sarefIsCommandOf map[string]SarefFunction
}

// propTimeAfterBaseTimeTemporalEntityTypeTimeTemporalEntitySingleTimeTemporalEntity is Gives directionality to time. If a temporal entity T1 is after another temporal entity T2, then the beginning of T1 is after the end of T2.
type propTimeAfterBaseTimeTemporalEntityTypeTimeTemporalEntitySingleTimeTemporalEntity struct {
	timeAfter TimeTemporalEntity
}

// propTimeHasBeginningBaseTimeInstantTypeTimeInstantSingleTimeInstant is Beginning of a temporal entity
type propTimeHasBeginningBaseTimeInstantTypeTimeInstantSingleTimeInstant struct {
	timeHasBeginning TimeInstant
}

// propTimeBeforeBaseTimeTemporalEntityTypeTimeTemporalEntitySingleTimeTemporalEntity is Gives directionality to time. If a temporal entity T1 is before another temporal entity T2, then the end of T1 is before the beginning of T2. Thus, \"before\" can be considered to be basic to instants and derived for intervals.
type propTimeBeforeBaseTimeTemporalEntityTypeTimeTemporalEntitySingleTimeTemporalEntity struct {
	timeBefore TimeTemporalEntity
}

// propTimeHasTemporalDurationBaseTimeTemporalDurationTypeTimeTemporalDurationSingleTimeTemporalDuration is Duration of a temporal entity.
type propTimeHasTemporalDurationBaseTimeTemporalDurationTypeTimeTemporalDurationSingleTimeTemporalDuration struct {
	timeHasTemporalDuration TimeTemporalDuration
}

// propTimeHasXSDDurationBaseGoDurationTypeGoDurationSingleGoDuration is Extent of a temporal entity, expressed using xsd:duration
type propTimeHasXSDDurationBaseGoDurationTypeGoDurationSingleGoDuration struct {
	timeHasXSDDuration time.Duration
}

// propTimeHasEndBaseTimeInstantTypeTimeInstantSingleTimeInstant is End of a temporal entity.
type propTimeHasEndBaseTimeInstantTypeTimeInstantSingleTimeInstant struct {
	timeHasEnd TimeInstant
}

// propTimeInsideBaseTimeInstantTypeTimeInstantSingleTimeInstant is An instant that falls inside the interval. It is not intended to include beginnings and ends of intervals.
type propTimeInsideBaseTimeInstantTypeTimeInstantSingleTimeInstant struct {
	timeInside TimeInstant
}

// propSarefIsMeasuredInBaseSarefUnitOfMeasureTypeSarefUnitOfMeasureMultipleSarefUnitOfMeasure is A relationship identifying the unit of measure used for a certain entity.
type propSarefIsMeasuredInBaseSarefUnitOfMeasureTypeSarefUnitOfMeasureMultipleSarefUnitOfMeasure struct {
	sarefIsMeasuredIn map[string]SarefUnitOfMeasure
}

// propTimeIntervalEqualsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval is If a proper interval T1 is intervalEquals another proper interval T2, then the beginning of T1 is coincident with the beginning of T2, and the end of T1 is coincident with the end of T2.
type propTimeIntervalEqualsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval struct {
	timeIntervalEquals TimeProperInterval
}

// propTimeIntervalStartsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval is If a proper interval T1 is intervalStarts another proper interval T2, then the beginning of T1 is coincident with the beginning of T2, and the end of T1 is before the end of T2.
type propTimeIntervalStartsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval struct {
	timeIntervalStarts TimeProperInterval
}

// propTimeIntervalContainsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval is If a proper interval T1 is intervalContains another proper interval T2, then the beginning of T1 is before the beginning of T2, and the end of T1 is after the end of T2.
type propTimeIntervalContainsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval struct {
	timeIntervalContains TimeProperInterval
}

// propTimeIntervalDisjointBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval is If a proper interval T1 is intervalDisjoint another proper interval T2, then the beginning of T1 is after the end of T2, or the end of T1 is before the beginning of T2, i.e. the intervals do not overlap in any way, but their ordering relationship is not known.
type propTimeIntervalDisjointBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval struct {
	timeIntervalDisjoint TimeProperInterval
}

// propTimeIntervalMeetsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval is If a proper interval T1 is intervalMeets another proper interval T2, then the end of T1 is coincident with the beginning of T2.
type propTimeIntervalMeetsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval struct {
	timeIntervalMeets TimeProperInterval
}

// propTimeIntervalAfterBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval is If a proper interval T1 is intervalAfter another proper interval T2, then the beginning of T1 is after the end of T2.
type propTimeIntervalAfterBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval struct {
	timeIntervalAfter TimeProperInterval
}

// propTimeIntervalOverlapsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval is If a proper interval T1 is intervalOverlaps another proper interval T2, then the beginning of T1 is before the beginning of T2, the end of T1 is after the beginning of T2, and the end of T1 is before the end of T2.
type propTimeIntervalOverlapsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval struct {
	timeIntervalOverlaps TimeProperInterval
}

// propTimeIntervalFinishedByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval is If a proper interval T1 is intervalFinishedBy another proper interval T2, then the beginning of T1 is before the beginning of T2, and the end of T1 is coincident with the end of T2.
type propTimeIntervalFinishedByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval struct {
	timeIntervalFinishedBy TimeProperInterval
}

// propTimeIntervalOverlappedByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval is If a proper interval T1 is intervalOverlappedBy another proper interval T2, then the beginning of T1 is after the beginning of T2, the beginning of T1 is before the end of T2, and the end of T1 is after the end of T2.
type propTimeIntervalOverlappedByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval struct {
	timeIntervalOverlappedBy TimeProperInterval
}

// propTimeIntervalBeforeBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval is If a proper interval T1 is intervalBefore another proper interval T2, then the end of T1 is before the beginning of T2.
type propTimeIntervalBeforeBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval struct {
	timeIntervalBefore TimeProperInterval
}

// propTimeIntervalDuringBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval is If a proper interval T1 is intervalDuring another proper interval T2, then the beginning of T1 is after the beginning of T2, and the end of T1 is before the end of T2.
type propTimeIntervalDuringBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval struct {
	timeIntervalDuring TimeProperInterval
}

// propTimeIntervalStartedByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval is If a proper interval T1 is intervalStarted another proper interval T2, then the beginning of T1 is coincident with the beginning of T2, and the end of T1 is after the end of T2.
type propTimeIntervalStartedByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval struct {
	timeIntervalStartedBy TimeProperInterval
}

// propTimeIntervalFinishesBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval is If a proper interval T1 is intervalFinishes another proper interval T2, then the beginning of T1 is after the beginning of T2, and the end of T1 is coincident with the end of T2.
type propTimeIntervalFinishesBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval struct {
	timeIntervalFinishes TimeProperInterval
}

// propTimeIntervalInBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval is If a proper interval T1 is intervalIn another proper interval T2, then the beginning of T1 is after the beginning of T2 or is coincident with the beginning of T2, and the end of T1 is before the end of T2, or is coincident with the end of T2, except that end of T1 may not be coincident with the end of T2 if the beginning of T1 is coincident with the beginning of T2.
type propTimeIntervalInBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval struct {
	timeIntervalIn TimeProperInterval
}

// propTimeIntervalMetByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval is If a proper interval T1 is intervalMetBy another proper interval T2, then the beginning of T1 is coincident with the end of T2.
type propTimeIntervalMetByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval struct {
	timeIntervalMetBy TimeProperInterval
}

// propTimeHasDateTimeDescriptionBaseTimeGeneralDateTimeDescriptionTypeTimeGeneralDateTimeDescriptionSingleTimeGeneralDateTimeDescription is Value of DateTimeInterval expressed as a structured value. The beginning and end of the interval coincide with the limits of the shortest element in the description.
type propTimeHasDateTimeDescriptionBaseTimeGeneralDateTimeDescriptionTypeTimeGeneralDateTimeDescriptionSingleTimeGeneralDateTimeDescription struct {
	timeHasDateTimeDescription TimeGeneralDateTimeDescription
}

// propTimeXsdDateTimeBaseGoTimeTypeGoTimeSingleGoTime is Value of DateTimeInterval expressed as a compact value.
type propTimeXsdDateTimeBaseGoTimeTypeGoTimeSingleGoTime struct {
	timeXsdDateTime time.Time
}

// propSarefActsUponBaseSarefStateTypeSarefStateMultipleSarefState is A relationship between a command and a state
type propSarefActsUponBaseSarefStateTypeSarefStateMultipleSarefState struct {
	sarefActsUpon map[string]SarefState
}

// propSarefConsistsOfBaseSarefDeviceTypeSarefMeterMultipleSarefMeter is A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
type propSarefConsistsOfBaseSarefDeviceTypeSarefMeterMultipleSarefMeter struct {
	sarefConsistsOf map[string]SarefMeter
}

// propSarefMeasuresPropertyBaseSarefPropertyTypeSarefEnergyMultipleSarefEnergy is A relationship specifying the Property that can be measured by a certain Device
type propSarefMeasuresPropertyBaseSarefPropertyTypeSarefEnergyMultipleSarefEnergy struct {
	sarefMeasuresProperty map[string]SarefEnergy
}

// propSarefIsControlledByDeviceBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice is A relationship specifying the devices that can control a certain property
type propSarefIsControlledByDeviceBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice struct {
	sarefIsControlledByDevice map[string]SarefDevice
}

// propSarefIsMeasuredByDeviceBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice is A relationship specifying the devices that can measure a certain property
type propSarefIsMeasuredByDeviceBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice struct {
	sarefIsMeasuredByDevice map[string]SarefDevice
}

// propSarefRelatesToMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement is A relationship between a property and the measurements it relates to
type propSarefRelatesToMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement struct {
	sarefRelatesToMeasurement map[string]SarefMeasurement
}

// propSarefConsistsOfBaseSarefDeviceTypeSarefSwitchMultipleSarefSwitch is A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
type propSarefConsistsOfBaseSarefDeviceTypeSarefSwitchMultipleSarefSwitch struct {
	sarefConsistsOf map[string]SarefSwitch
}

// propSarefHasStateBaseSarefStateTypeSarefOpenCloseStateMultipleSarefOpenCloseState is A relationship identifying the type of state of a device
type propSarefHasStateBaseSarefStateTypeSarefOpenCloseStateMultipleSarefOpenCloseState struct {
	sarefHasState map[string]SarefOpenCloseState
}

// propSarefHasFunctionBaseSarefFunctionTypeSarefOpenCloseFunctionMultipleSarefOpenCloseFunction is A relationship identifying the type of function of a device
type propSarefHasFunctionBaseSarefFunctionTypeSarefOpenCloseFunctionMultipleSarefOpenCloseFunction struct {
	sarefHasFunction map[string]SarefOpenCloseFunction
}

// propTimeHasTRSBaseTimeTRSTypeTimeTRSSingleTimeTRS is The temporal reference system used by a temporal position or extent description. 
type propTimeHasTRSBaseTimeTRSTypeTimeTRSSingleTimeTRS struct {
	timeHasTRS TimeTRS
}

// propTimeUnitTypeBaseTimeTemporalUnitTypeTimeTemporalUnitSingleTimeTemporalUnit is The temporal unit which provides the precision of a date-time value or scale of a temporal extent
type propTimeUnitTypeBaseTimeTemporalUnitTypeTimeTemporalUnitSingleTimeTemporalUnit struct {
	timeUnitType TimeTemporalUnit
}

// propTimeDayOfWeekBaseTimeDayOfWeekTypeTimeDayOfWeekSingleTimeDayOfWeek is The day of week, whose value is a member of the class time:DayOfWeek
type propTimeDayOfWeekBaseTimeDayOfWeekTypeTimeDayOfWeekSingleTimeDayOfWeek struct {
	timeDayOfWeek TimeDayOfWeek
}

// propTimeDayOfYearBaseintTypeintSingleint is The number of the day within the year
type propTimeDayOfYearBaseintTypeintSingleint struct {
	timeDayOfYear int
}

// propTimeHourBaseintTypeintSingleint is Hour position in a calendar-clock system.
type propTimeHourBaseintTypeintSingleint struct {
	timeHour int
}

// propTimeMinuteBaseintTypeintSingleint is Minute position in a calendar-clock system.
type propTimeMinuteBaseintTypeintSingleint struct {
	timeMinute int
}

// propTimeMonthOfYearBaseTimeMonthOfYearTypeTimeMonthOfYearSingleTimeMonthOfYear is The month of the year, whose value is a member of the class time:MonthOfYear
type propTimeMonthOfYearBaseTimeMonthOfYearTypeTimeMonthOfYearSingleTimeMonthOfYear struct {
	timeMonthOfYear TimeMonthOfYear
}

// propTimeSecondBasefloat64Typefloat64Singlefloat64 is Second position in a calendar-clock system.
type propTimeSecondBasefloat64Typefloat64Singlefloat64 struct {
	timeSecond float64
}

// propTimeZoneBaseTimeZoneTypeTimeZoneSingleTimeZone is The time zone for clock elements in the temporal position
type propTimeZoneBaseTimeZoneTypeTimeZoneSingleTimeZone struct {
	timeZone TimeZone
}

// propTimeWeekBaseintTypeintSingleint is Week number within the year.
type propTimeWeekBaseintTypeintSingleint struct {
	timeWeek int
}

// propSarefIsOfferedByBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice is A relationship between a service and a device that offers the service
type propSarefIsOfferedByBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice struct {
	sarefIsOfferedBy map[string]SarefDevice
}

// propSarefRepresentsBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction is A relationship between a service and a function.
type propSarefRepresentsBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction struct {
	sarefRepresents map[string]SarefFunction
}

// propSarefActsUponBaseSarefStateTypeSarefOnOffStateMultipleSarefOnOffState is A relationship between a command and a state
type propSarefActsUponBaseSarefStateTypeSarefOnOffStateMultipleSarefOnOffState struct {
	sarefActsUpon map[string]SarefOnOffState
}

// propSarefHasCommandBaseSarefCommandTypeSarefNotifyCommandMultipleSarefNotifyCommand is A relationship between an entity (such as a function) and a command
type propSarefHasCommandBaseSarefCommandTypeSarefNotifyCommandMultipleSarefNotifyCommand struct {
	sarefHasCommand map[string]SarefNotifyCommand
}

// propSarefHasThresholdMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement is A relationship associated with an event function to notify that a certain threshold measurement has been exceeded
type propSarefHasThresholdMeasurementBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement struct {
	sarefHasThresholdMeasurement map[string]SarefMeasurement
}

// propSarefHasFunctionBaseSarefFunctionTypeSarefActuatingFunctionMultipleSarefActuatingFunction is A relationship identifying the type of function of a device
type propSarefHasFunctionBaseSarefFunctionTypeSarefActuatingFunctionMultipleSarefActuatingFunction struct {
	sarefHasFunction map[string]SarefActuatingFunction
}

// propSarefHasCommandBaseSarefCommandTypeSarefGetSensingDataCommandMultipleSarefGetSensingDataCommand is A relationship between an entity (such as a function) and a command
type propSarefHasCommandBaseSarefCommandTypeSarefGetSensingDataCommandMultipleSarefGetSensingDataCommand struct {
	sarefHasCommand map[string]SarefGetSensingDataCommand
}

// propSarefHasSensingRangeBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement is A relationship between a sensing function and a measurement identifying the range of a sensor detection
type propSarefHasSensingRangeBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement struct {
	sarefHasSensingRange map[string]SarefMeasurement
}

// propSarefHasSensorTypeBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty is A relationship identifying the sensing type of a sensor detection (i.e., Temperature, Occupancy, Humidity, Motion , Smoke, Pressure, etc.) 
type propSarefHasSensorTypeBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty struct {
	sarefHasSensorType map[string]SarefProperty
}

// propTimeDayBaseGoTimeTypeGoTimeSingleGoTime is Day position in a calendar-clock system.The range of this property is not specified, so can be replaced by any specific representation of a calendar day from any calendar. 
type propTimeDayBaseGoTimeTypeGoTimeSingleGoTime struct {
	timeDay time.Time
}

// propTimeMonthBaseGoTimeTypeGoTimeSingleGoTime is Month position in a calendar-clock system.The range of this property is not specified, so can be replaced by any specific representation of a calendar month from any calendar. 
type propTimeMonthBaseGoTimeTypeGoTimeSingleGoTime struct {
	timeMonth time.Time
}

// propTimeYearBaseGoTimeTypeGoTimeSingleGoTime is Year position in a calendar-clock system.The range of this property is not specified, so can be replaced by any specific representation of a calendar year from any calendar. 
type propTimeYearBaseGoTimeTypeGoTimeSingleGoTime struct {
	timeYear time.Time
}

// propSarefHasFunctionBaseSarefFunctionTypeSarefSensingFunctionMultipleSarefSensingFunction is A relationship identifying the type of function of a device
type propSarefHasFunctionBaseSarefFunctionTypeSarefSensingFunctionMultipleSarefSensingFunction struct {
	sarefHasFunction map[string]SarefSensingFunction
}

// propSarefIsAccomplishedByBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice is A relationship indentifying the task accomplished by a certain entity (e.g., a device)
type propSarefIsAccomplishedByBaseSarefDeviceTypeSarefDeviceMultipleSarefDevice struct {
	sarefIsAccomplishedBy map[string]SarefDevice
}

// propSarefActsUponBaseSarefStateTypeSarefStartStopStateMultipleSarefStartStopState is A relationship between a command and a state
type propSarefActsUponBaseSarefStateTypeSarefStartStopStateMultipleSarefStartStopState struct {
	sarefActsUpon map[string]SarefStartStopState
}

// propSarefConsistsOfBaseSarefDeviceTypeSarefSensorMultipleSarefSensor is A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
type propSarefConsistsOfBaseSarefDeviceTypeSarefSensorMultipleSarefSensor struct {
	sarefConsistsOf map[string]SarefSensor
}

// propSarefMeasuresPropertyBaseSarefPropertyTypeSarefTemperatureMultipleSarefTemperature is A relationship specifying the Property that can be measured by a certain Device
type propSarefMeasuresPropertyBaseSarefPropertyTypeSarefTemperatureMultipleSarefTemperature struct {
	sarefMeasuresProperty map[string]SarefTemperature
}

// propTimeNumericPositionBasefloat64Typefloat64Singlefloat64 is The (numeric) value indicating position within a temporal coordinate system 
type propTimeNumericPositionBasefloat64Typefloat64Singlefloat64 struct {
	timeNumericPosition float64
}

// propTimeNominalPositionBasestringTypestringSinglestring is The (nominal) value indicating temporal position in an ordinal reference system 
type propTimeNominalPositionBasestringTypestringSinglestring struct {
	timeNominalPosition string
}

// propSarefHasCommandBaseSarefCommandTypeSarefCommandMultipleSarefSetAbsoluteLevelCommandSarefSetRelativeLevelCommandSarefStepDownCommandSarefStepUpCommand is A relationship between an entity (such as a function) and a command
type propSarefHasCommandBaseSarefCommandTypeSarefCommandMultipleSarefSetAbsoluteLevelCommandSarefSetRelativeLevelCommandSarefStepDownCommandSarefStepUpCommand struct {
	sarefHasCommand map[string]SarefCommand
}

// propSarefHasCommandBaseSarefCommandTypeSarefCommandMultipleSarefCloseCommandSarefOpenCommand is A relationship between an entity (such as a function) and a command
type propSarefHasCommandBaseSarefCommandTypeSarefCommandMultipleSarefCloseCommandSarefOpenCommand struct {
	sarefHasCommand map[string]SarefCommand
}

// propSarefConsistsOfBaseSarefProfileTypeSarefProfileMultipleSarefProfile is A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
type propSarefConsistsOfBaseSarefProfileTypeSarefProfileMultipleSarefProfile struct {
	sarefConsistsOf map[string]SarefProfile
}

// propSarefHasPriceBaseSarefPriceTypeSarefPriceMultipleSarefPrice is A relationships indentifying the price associated to an entity
type propSarefHasPriceBaseSarefPriceTypeSarefPriceMultipleSarefPrice struct {
	sarefHasPrice map[string]SarefPrice
}

// propSarefHasTimeBaseSarefTimeTypeSarefTimeMultipleSarefTime is A relationship to associate time information to an entity
type propSarefHasTimeBaseSarefTimeTypeSarefTimeMultipleSarefTime struct {
	sarefHasTime map[string]SarefTime
}

// propSarefIsAboutBaseThingTypeThingMultipleSarefCommoditySarefProperty is A relationship identifying what an entity, such as a Profile, is about
type propSarefIsAboutBaseThingTypeThingMultipleSarefCommoditySarefProperty struct {
	sarefIsAbout map[string]owl.Thing
}

// propSarefHasCommandBaseSarefCommandTypeSarefCommandMultipleSarefCommand is A relationship between an entity (such as a function) and a command
type propSarefHasCommandBaseSarefCommandTypeSarefCommandMultipleSarefCommand struct {
	sarefHasCommand map[string]SarefCommand
}

// propTimeNumericDurationBasefloat64Typefloat64Singlefloat64 is Value of a temporal extent expressed as a decimal number scaled by a temporal unit
type propTimeNumericDurationBasefloat64Typefloat64Singlefloat64 struct {
	timeNumericDuration float64
}

// propSarefActsUponBaseSarefStateTypeSarefOpenCloseStateMultipleSarefOpenCloseState is A relationship between a command and a state
type propSarefActsUponBaseSarefStateTypeSarefOpenCloseStateMultipleSarefOpenCloseState struct {
	sarefActsUpon map[string]SarefOpenCloseState
}

// propSarefMeasuresPropertyBaseSarefPropertyTypeSarefSmokeMultipleSarefSmoke is A relationship specifying the Property that can be measured by a certain Device
type propSarefMeasuresPropertyBaseSarefPropertyTypeSarefSmokeMultipleSarefSmoke struct {
	sarefMeasuresProperty map[string]SarefSmoke
}

// propSarefHasFunctionBaseSarefFunctionTypeSarefFunctionMultipleSarefEventFunctionSarefSensingFunction is A relationship identifying the type of function of a device
type propSarefHasFunctionBaseSarefFunctionTypeSarefFunctionMultipleSarefEventFunctionSarefSensingFunction struct {
	sarefHasFunction map[string]SarefFunction
}

// propSarefConsistsOfBaseTimeTemporalEntityTypeTimeTemporalEntityMultipleTimeTemporalEntity is A relationship indicating a composite entity that consists of other entities (e.g., a temperature/humidity sensor that consists of a temperature sensor and a humidity sensor)
type propSarefConsistsOfBaseTimeTemporalEntityTypeTimeTemporalEntityMultipleTimeTemporalEntity struct {
	sarefConsistsOf map[string]TimeTemporalEntity
}

// propTimeDaysBasefloat64Typefloat64Singlefloat64 is length of, or element of the length of, a temporal extent expressed in days
type propTimeDaysBasefloat64Typefloat64Singlefloat64 struct {
	timeDays float64
}

// propTimeHoursBasefloat64Typefloat64Singlefloat64 is length of, or element of the length of, a temporal extent expressed in hours
type propTimeHoursBasefloat64Typefloat64Singlefloat64 struct {
	timeHours float64
}

// propTimeMinutesBasefloat64Typefloat64Singlefloat64 is length, or element of, a temporal extent expressed in minutes
type propTimeMinutesBasefloat64Typefloat64Singlefloat64 struct {
	timeMinutes float64
}

// propTimeMonthsBasefloat64Typefloat64Singlefloat64 is length of, or element of the length of, a temporal extent expressed in months
type propTimeMonthsBasefloat64Typefloat64Singlefloat64 struct {
	timeMonths float64
}

// propTimeSecondsBasefloat64Typefloat64Singlefloat64 is length of, or element of the length of, a temporal extent expressed in seconds
type propTimeSecondsBasefloat64Typefloat64Singlefloat64 struct {
	timeSeconds float64
}

// propTimeWeeksBasefloat64Typefloat64Singlefloat64 is length of, or element of the length of, a temporal extent expressed in weeks
type propTimeWeeksBasefloat64Typefloat64Singlefloat64 struct {
	timeWeeks float64
}

// propTimeYearsBasefloat64Typefloat64Singlefloat64 is length of, or element of the length of, a temporal extent expressed in years
type propTimeYearsBasefloat64Typefloat64Singlefloat64 struct {
	timeYears float64
}

// propSarefIsOfferedByBaseSarefDeviceTypeSarefLightSwitchMultipleSarefLightSwitch is A relationship between a service and a device that offers the service
type propSarefIsOfferedByBaseSarefDeviceTypeSarefLightSwitchMultipleSarefLightSwitch struct {
	sarefIsOfferedBy map[string]SarefLightSwitch
}

// propSarefRepresentsBaseSarefFunctionTypeSarefOnOffFunctionMultipleSarefOnOffFunction is A relationship between a service and a function.
type propSarefRepresentsBaseSarefFunctionTypeSarefOnOffFunctionMultipleSarefOnOffFunction struct {
	sarefRepresents map[string]SarefOnOffFunction
}

// propSarefHasCommandBaseSarefCommandTypeSarefCommandMultipleSarefStartCommandSarefStopCommand is A relationship between an entity (such as a function) and a command
type propSarefHasCommandBaseSarefCommandTypeSarefCommandMultipleSarefStartCommandSarefStopCommand struct {
	sarefHasCommand map[string]SarefCommand
}

// propSarefHasCommandBaseSarefCommandTypeSarefGetCommandMultipleSarefGetCurrentMeterValueCommandSarefGetMeterDataCommandSarefGetMeterHistoryCommand is A relationship between an entity (such as a function) and a command
type propSarefHasCommandBaseSarefCommandTypeSarefGetCommandMultipleSarefGetCurrentMeterValueCommandSarefGetMeterDataCommandSarefGetMeterHistoryCommand struct {
	sarefHasCommand map[string]SarefGetCommand
}

// propSarefHasMeterReadingBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement is A relationship between a metering function and the measurement of the reading
type propSarefHasMeterReadingBaseSarefMeasurementTypeSarefMeasurementMultipleSarefMeasurement struct {
	sarefHasMeterReading map[string]SarefMeasurement
}

// propSarefHasMeterReadingTypeBaseThingTypeThingMultipleSarefCommoditySarefProperty is A relationship identifying the reading type of a measurement (e.g., Water, Gas, Pressure , Energy , Power, etc.)
type propSarefHasMeterReadingTypeBaseThingTypeThingMultipleSarefCommoditySarefProperty struct {
	sarefHasMeterReadingType map[string]owl.Thing
}

// propSarefRelatesToPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty is A relationship between a measurement and the property it relates to
type propSarefRelatesToPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty struct {
	sarefRelatesToProperty map[string]SarefProperty
}

// propSarefHasTimestampBaseGoTimeTypeGoTimeMultipleGoTime is A relationship stating the timestamp of an entity (e.g. a measurement).
type propSarefHasTimestampBaseGoTimeTypeGoTimeMultipleGoTime struct {
	sarefHasTimestamp []time.Time
}

// propSarefHasValueBasefloat64Typefloat64Singlefloat64 is A relationship defining the value of a certain property, e.g., energy or power
type propSarefHasValueBasefloat64Typefloat64Singlefloat64 struct {
	sarefHasValue float64
}

// propSarefHasCommandBaseSarefCommandTypeSarefCommandMultipleSarefOffCommandSarefOnCommandSarefToggleCommand is A relationship between an entity (such as a function) and a command
type propSarefHasCommandBaseSarefCommandTypeSarefCommandMultipleSarefOffCommandSarefOnCommandSarefToggleCommand struct {
	sarefHasCommand map[string]SarefCommand
}

// propTimeInXSDDateTimeStampBaseGoTimeTypeGoTimeSingleGoTime is Position of an instant, expressed using xsd:dateTimeStamp
type propTimeInXSDDateTimeStampBaseGoTimeTypeGoTimeSingleGoTime struct {
	timeInXSDDateTimeStamp time.Time
}

// propTimeInXSDgYearMonthBaseGoTimeTypeGoTimeSingleGoTime is Position of an instant, expressed using xsd:gYearMonth
type propTimeInXSDgYearMonthBaseGoTimeTypeGoTimeSingleGoTime struct {
	timeInXSDgYearMonth time.Time
}

// propTimeInTemporalPositionBaseTimeTemporalPositionTypeTimeTemporalPositionSingleTimeTemporalPosition is Position of a time instant
type propTimeInTemporalPositionBaseTimeTemporalPositionTypeTimeTemporalPositionSingleTimeTemporalPosition struct {
	timeInTemporalPosition TimeTemporalPosition
}

// propTimeInXSDDateTimeBaseGoTimeTypeGoTimeSingleGoTime is Position of an instant, expressed using xsd:dateTime
type propTimeInXSDDateTimeBaseGoTimeTypeGoTimeSingleGoTime struct {
	timeInXSDDateTime time.Time
}

// propTimeInXSDDateBaseGoTimeTypeGoTimeSingleGoTime is Position of an instant, expressed using xsd:date
type propTimeInXSDDateBaseGoTimeTypeGoTimeSingleGoTime struct {
	timeInXSDDate time.Time
}

// propTimeInDateTimeBaseTimeGeneralDateTimeDescriptionTypeTimeGeneralDateTimeDescriptionSingleTimeGeneralDateTimeDescription is Position of an instant, expressed using a structured description
type propTimeInDateTimeBaseTimeGeneralDateTimeDescriptionTypeTimeGeneralDateTimeDescriptionSingleTimeGeneralDateTimeDescription struct {
	timeInDateTime TimeGeneralDateTimeDescription
}

// propTimeInXSDgYearBaseGoTimeTypeGoTimeSingleGoTime is Position of an instant, expressed using xsd:gYear
type propTimeInXSDgYearBaseGoTimeTypeGoTimeSingleGoTime struct {
	timeInXSDgYear time.Time
}

// propTimeInTimePositionBaseTimePositionTypeTimePositionSingleTimePosition is Position of an instant, expressed as a temporal coordinate or nominal value
type propTimeInTimePositionBaseTimePositionTypeTimePositionSingleTimePosition struct {
	timeInTimePosition TimePosition
}

// propSarefHasStateBaseSarefStateTypeSarefStartStopStateMultipleSarefStartStopState is A relationship identifying the type of state of a device
type propSarefHasStateBaseSarefStateTypeSarefStartStopStateMultipleSarefStartStopState struct {
	sarefHasState map[string]SarefStartStopState
}

// propSarefHasFunctionBaseSarefFunctionTypeSarefStartStopFunctionMultipleSarefStartStopFunction is A relationship identifying the type of function of a device
type propSarefHasFunctionBaseSarefFunctionTypeSarefStartStopFunctionMultipleSarefStartStopFunction struct {
	sarefHasFunction map[string]SarefStartStopFunction
}

// propSarefHasStateBaseSarefStateTypeSarefOnOffStateMultipleSarefOnOffState is A relationship identifying the type of state of a device
type propSarefHasStateBaseSarefStateTypeSarefOnOffStateMultipleSarefOnOffState struct {
	sarefHasState map[string]SarefOnOffState
}

// propSarefMeasuresPropertyBaseSarefPropertyTypeSarefLightMultipleSarefLight is A relationship specifying the Property that can be measured by a certain Device
type propSarefMeasuresPropertyBaseSarefPropertyTypeSarefLightMultipleSarefLight struct {
	sarefMeasuresProperty map[string]SarefLight
}

// propSarefOffersBaseSarefServiceTypeSarefSwitchOnServiceMultipleSarefSwitchOnService is A relationship between a device and a service
type propSarefOffersBaseSarefServiceTypeSarefSwitchOnServiceMultipleSarefSwitchOnService struct {
	sarefOffers map[string]SarefSwitchOnService
}

// propSarefHasFunctionBaseSarefFunctionTypeSarefOnOffFunctionMultipleSarefOnOffFunction is A relationship identifying the type of function of a device
type propSarefHasFunctionBaseSarefFunctionTypeSarefOnOffFunctionMultipleSarefOnOffFunction struct {
	sarefHasFunction map[string]SarefOnOffFunction
}


